﻿UsePNGImageDecoder()
UseSQLiteDatabase()

DeclareModule Locale
  
  ;Structure to store languages available to this application
  Structure Language
    Title.s
    Code.s
  EndStructure
  
  ;Default language variable
  Global AppLanguage.s
  
  Declare Initialise()
  Declare SelectLanguage()
  Declare FetchAvailableLanguages()
  
  ;My Application String Variables
  Global AP_0001.s
  Global AP_0002.s
  Global AP_0003.s
  
  ;Common Word String Variables
Global CM_0001.s
Global CM_0002.s
Global CM_0003.s
Global CM_0004.s
Global CM_0005.s
Global CM_0006.s
Global CM_0007.s
Global CM_0008.s
Global CM_0009.s
Global CM_0010.s
Global CM_0011.s
Global CM_0012.s
Global CM_0013.s
Global CM_0014.s
Global CM_0015.s
Global CM_0016.s
Global CM_0017.s
Global CM_0018.s
Global CM_0019.s
Global CM_0020.s
Global CM_0021.s
Global CM_0022.s
Global CM_0023.s
Global CM_0024.s
Global CM_0025.s
Global CM_0026.s
Global CM_0027.s
Global CM_0028.s
Global CM_0029.s
Global CM_0030.s
Global CM_0031.s
Global CM_0032.s
Global CM_0033.s
Global CM_0034.s
Global CM_0035.s
Global CM_0036.s
Global CM_0037.s
Global CM_0038.s
Global CM_0039.s
Global CM_0040.s
Global CM_0041.s
Global CM_0042.s
Global CM_0043.s
Global CM_0044.s
Global CM_0045.s
Global CM_0046.s
Global CM_0047.s
Global CM_0048.s
Global CM_0049.s
Global CM_0050.s
Global CM_0051.s
Global CM_0052.s
Global CM_0053.s
Global CM_0054.s
Global CM_0055.s
Global CM_0056.s
Global CM_0057.s
Global CM_0058.s
Global CM_0059.s
Global CM_0060.s
Global CM_0061.s
Global CM_0062.s
Global CM_0063.s
Global CM_0064.s
Global CM_0065.s
Global CM_0066.s
Global CM_0067.s
Global CM_0068.s
Global CM_0069.s

;Media Player Variables
Global MP_0001.s
Global MP_0002.s
Global MP_0003.s
Global MP_0004.s
Global MP_0005.s
Global MP_0006.s
Global MP_0007.s
Global MP_0008.s
Global MP_0009.s

;Database Variables
Global DB_0001.s
Global DB_0002.s
Global DB_0003.s
Global DB_0004.s
Global DB_0005.s

;Error Variables
Global ER_0001.s
  
EndDeclareModule

Module Locale
  
  Global Dim Available.Language(0)
  Global cmbLanguage.i
  Global NewMap Lang.s()
  
  Procedure FetchAvailableLanguages()
    
    Define ExamDir.i, iLoop.i
    Define FName.s, Criteria.s
    
    iLoop = 0
    ReDim Available(iLoop)
    ExamDir = ExamineDirectory(#PB_Any,GetCurrentDirectory() + "Resources","*.lng")
    While NextDirectoryEntry(ExamDir)
      type=DirectoryEntryType(ExamDir)
      FName=DirectoryEntryName(ExamDir)
      Available(iLoop)\Code = GetFilePart(FName,#PB_FileSystem_NoExtension) 
      iLoop = iLoop + 1
      ReDim Available(iLoop)
    Wend
    FinishDirectory(ExamDir)
    
    ;Load Languages
    For iLoop = 0 To ArraySize(Available())-1
      If IsImage(imgcnb)
        FreeImage(imgcmb)
      EndIf
      imgcmb = LoadImage(#PB_Any,GetCurrentDirectory() + "Resources\" + Available(iLoop)\Code + ".png")
      DBID = OpenDatabase(#PB_Any,GetCurrentDirectory() + "Resources\" + Available(iLoop)\Code + ".lng","","")  
      Criteria = "SELECT Title,Code FROM Language;"
      DatabaseQuery(DBID,criteria)
      FirstDatabaseRow(DBID)
      Available(iLoop)\Title = GetDatabaseString(DBID,0)
      FinishDatabaseQuery(DBID)
    Next iLoop
  
EndProcedure 

  Procedure AssignStrings(Language.s)
    
  Define iLoop.i = 0
  Define Criteria.s, Selected.s
  
  ClearMap(Lang())
  
  ;Selected = Available(GetGadgetItemData(cmbLanguage, GetGadgetState(cmbLanguage)))
    
  Criteria = "SELECT Key,Phrase From Phrases;"

  DBID = OpenDatabase(#PB_Any,GetCurrentDirectory() + "Resources\" + Language + ".lng","","")  
  DatabaseQuery(DBID,Criteria)
  FirstDatabaseRow(DBID)
  AddMapElement(Lang(), GetDatabaseString(DBID, 0))
  Lang() = GetDatabaseString(DBID, 1)
  While NextDatabaseRow(DBID)
    AddMapElement(Lang(), GetDatabaseString(DBID, 0))
    Lang() = GetDatabaseString(DBID, 1)
  Wend
  FinishDatabaseQuery(DBID)
  
  ;My Application Word Assignment

  If FindMapElement(Lang(), "AP_0001") > 0
    AP_0001=Lang()
  EndIf

  If FindMapElement(Lang(), "AP_0002") > 0
    AP_0002 = Lang()
  EndIf

  If FindMapElement(Lang(), "AP_0003") > 0
    AP_0003=Lang()
  EndIf   
  
  ;Common Word Assignment

  If FindMapElement(Lang(), "CM_0001") > 0
    CM_0001=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0002") > 0
    CM_0002=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0003") > 0
    CM_0003=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0004") > 0
    CM_0004=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0005") > 0
    CM_0005=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0006") > 0
    CM_0006=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0007") > 0
    CM_0007=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0008") > 0
    CM_0008=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0009") > 0
    CM_0009=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0010") > 0
    CM_0010=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0011") > 0
    CM_0011=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0012") > 0
    CM_0012=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0013") > 0
    CM_0013=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0014") > 0
    CM_0014=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0015") > 0
    CM_0015=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0016") > 0
    CM_0016=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0017") > 0
    CM_0017=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0018") > 0
    CM_0018=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0019") > 0
    CM_0019=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0020") > 0
    CM_0020=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0021") > 0
    CM_0021=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0022") > 0
    CM_0022=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0023") > 0
    CM_0023=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0024") > 0
    CM_0024=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0025") > 0
    CM_0025=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0026") > 0
    CM_0026=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0027") > 0
    CM_0027=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0028") > 0
    CM_0028=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0029") > 0
    CM_0029=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0030") > 0
    CM_0030=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0031") > 0
    CM_0031=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0032") > 0
    CM_0032=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0033") > 0
    CM_0033=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0034") > 0
    CM_0034=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0035") > 0
    CM_0035=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0036") > 0
    CM_0036=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0037") > 0
    CM_0037=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0038") > 0
    CM_0038=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0039") > 0
    CM_0039=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0040") > 0
    CM_0040=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0041") > 0
    CM_0041=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0042") > 0
    CM_0042=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0043") > 0
    CM_0043=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0044") > 0
    CM_0044=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0045") > 0
    CM_0045=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0046") > 0
    CM_0046=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0047") > 0
    CM_0047=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0048") > 0
    CM_0048=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0049") > 0
    CM_0049=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0050") > 0
    CM_0050=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0051") > 0
    CM_0051=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0052") > 0
    CM_0052=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0053") > 0
    CM_0053=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0054") > 0
    CM_0054=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0055") > 0
    CM_0055=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0056") > 0
    CM_0056=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0057") > 0
    CM_0057=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0058") > 0
    CM_0058=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0059") > 0
    CM_0059=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0060") > 0
    CM_0060=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0061") > 0
    CM_0061=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0062") > 0
    CM_0062=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0063") > 0
    CM_0063=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0064") > 0
    CM_0064=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0065") > 0
    CM_0065=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0066") > 0
    CM_0066=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0067") > 0
    CM_0067=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0068") > 0
    CM_0068=Lang()
  EndIf

  If FindMapElement(Lang(), "CM_0069") > 0
    CM_0069=Lang()
  EndIf
  
  ;Media Assignment
  If FindMapElement(Lang(), "MP_0001") > 0
    MP_0001=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0002") > 0
    MP_0002=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0003") > 0
    MP_0003=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0004") > 0
    MP_0004=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0005") > 0
    MP_0005=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0006") > 0
    MP_0006=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0007") > 0
    MP_0007=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0008") > 0
    MP_0008=Lang()
  EndIf

  If FindMapElement(Lang(), "MP_0009") > 0
    MP_0009=Lang()
  EndIf


;Database Assignment
  If FindMapElement(Lang(), "DB_0001") > 0
    DB_0001=Lang()
  EndIf

  If FindMapElement(Lang(), "DB_0002") > 0
    DB_0002=Lang()
  EndIf

  If FindMapElement(Lang(), "DB_0003") > 0
    DB_0003=Lang()
  EndIf

  If FindMapElement(Lang(), "DB_0004") > 0
    DB_0004=Lang()
  EndIf

  If FindMapElement(Lang(), "DB_0005") > 0
    DB_0005=Lang()
  EndIf

  ;Error Assignment
  If FindMapElement(Lang(), "ER_0001") > 0
    ER_0001=Lang()
  EndIf

EndProcedure

  Procedure Initialise()
    
    FetchAvailableLanguages()
    AssignStrings(Locale::AppLanguage)
    
  EndProcedure
  
  Procedure SelectLanguage()
    
    Define dlgChooseLanguage.i, btnOk.i, imgcmb.i
    
    dlgChooseLanguage = OpenWindow(#PB_Any, 0, 0, 160, 100, "", #PB_Window_Tool | #PB_Window_ScreenCentered)
    cmbLanguage = ComboBoxGadget(#PB_Any, 10, 30, 140, 20,#PB_ComboBox_Image)
    btnOk = ButtonGadget(#PB_Any, 90, 60, 60, 30, Locale::CM_0001)
    StickyWindow(dlgChooseLanguage,#True)
    
    ;Load Languages
    For iLoop = 0 To ArraySize(Available())-1
      If IsImage(imgcmb)
        FreeImage(imgcmb)
      EndIf
      imgcmb = LoadImage(#PB_Any,GetCurrentDirectory() + "Resources\" + Available(iLoop)\Code + ".png")
      AddGadgetItem(cmbLanguage,iLoop,Available(iLoop)\Title,ImageID(imgcmb))
      SetGadgetItemData(cmbLanguage,iLoop,iLoop)
    Next iLoop
    SetGadgetState(cmbLanguage,0)    
    
    Repeat
    
      Event = WaitWindowEvent() 
      Select event

        Case #PB_Event_Gadget
          Select EventGadget()
            Case btnOk
              AssignStrings(Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Code)  
              AppLanguage = Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Code
              CloseWindow(dlgChooseLanguage)
              Break
          EndSelect
      EndSelect
      
    ForEver
    
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; CursorPosition = 17
; Folding = r-
; EnableUnicode
; EnableXP